<?php
/*
 * Installs fields and field instances for certification entity
 *
 */
function civicrm_certify_certification_fields() {
  // create the authorized user field if it does not exist
  if (!field_info_field('field_certified_auth_user')) {
    $field = array(
      'active' => '1',
      'cardinality' => '1',
      'deleted' => '0',
      'entity_types' => array(),
      'field_name' => 'field_certified_auth_user',
      'foreign keys' => array(),
      'indexes' => array(),
      'locked' => '1',
      'module' => 'civicrm_contact_ref',
      'required' => '1',
      'settings' => array(
        'allowed_values' => array(
          'Individual' => array(
            'Individual' => 0,
            'Parent' => 0,
            'Staff' => 0,
            'Student' => 0,
          ),
          'Household' => array(
            'Household' => 0,
          ),
          'Organization' => array(
            'Organization' => 0,
            'Sponsor' => 0,
            'Team' => 0,
          ),
        ),
      ),
      'translatable' => '0',
      'type' => 'civicrm_contact_ref_contact',
    );
    field_create_field($field);

    // Create the 'authorized user' instance on the bundle.
    $instance = array(
      'bundle' => 'certification',
      'default_value' => NULL,
      'deleted' => '0',
      'description' => '',
      'locked' => '1',
      'display' => array(
        'default' => array(
          'label' => 'above',
          'module' => 'civicrm_contact_ref',
          'settings' => array(),
          'type' => 'civicrm_contact_ref_link',
          'weight' => '1',
        ),
      ),
      'entity_type' => 'certification',
      'field_name' => 'field_certified_auth_user',
      'label' => 'Certification Authorized By',
      'required' => 1,
      'settings' => array(
        'user_register_form' => FALSE,
      ),
      'widget' => array(
        'active' => 0,
        'module' => 'civicrm_contact_ref',
        'settings' => array(
          'autocomplete_path' => 'civicrm_contact_ref/autocomplete',
          'size' => 60,
        ),
        'type' => 'civicrm_contact_ref_autocomplete',
        'weight' => '2',
      ),
    );
    field_create_instance($instance);
  }
  // create the certified user field if it does not exist
  if (!field_info_field('field_certified_user')) {
    $field = array(
      'active' => '1',
      'cardinality' => '1',
      'deleted' => '0',
      'entity_types' => array(),
      'field_name' => 'field_certified_user',
      'foreign keys' => array(),
      'indexes' => array(),
      'locked' => '1',
      'module' => 'civicrm_contact_ref',
      'required' => '1',
      'settings' => array(
        'allowed_values' => array(
          'Individual' => array(
            'Individual' => 0,
            'Parent' => 0,
            'Staff' => 0,
            'Student' => 0,
          ),
          'Household' => array(
            'Household' => 0,
          ),
          'Organization' => array(
            'Organization' => 0,
            'Sponsor' => 0,
            'Team' => 0,
          ),
        ),
      ),
      'translatable' => '0',
      'type' => 'civicrm_contact_ref_contact',
    );
    field_create_field($field);

    // Create the 'certified user' instance on the bundle.
    $instance = array(
      'bundle' => 'certification',
      'default_value' => NULL,
      'deleted' => '0',
      'description' => '',
      'locked' => '1',
      'display' => array(
        'default' => array(
          'label' => 'above',
          'module' => 'civicrm_contact_ref',
          'settings' => array(),
          'type' => 'civicrm_contact_ref_link',
          'weight' => '0',
        ),
      ),
      'entity_type' => 'certification',
      'field_name' => 'field_certified_user',
      'label' => 'Certified User',
      'required' => 1,
      'settings' => array(
        'user_register_form' => FALSE,
      ),
      'widget' => array(
        'active' => 0,
        'module' => 'civicrm_contact_ref',
        'settings' => array(
          'autocomplete_path' => 'civicrm_contact_ref/autocomplete',
          'size' => 60,
        ),
        'type' => 'civicrm_contact_ref_autocomplete',
        'weight' => '1',
      ),
    );
    field_create_instance($instance);
  }

  // create the field_certified_rule_ref field if it does not exist
  if (!field_info_field('field_certified_rule_ref')) {
    $field = array(
      'active' => '1',
      'cardinality' => '1',
      'deleted' => '0',
      'entity_types' => array(),
      'field_name' => 'field_certified_rule_ref',
      'foreign keys' => array(
        'node' => array(
          'columns' => array(
            'target_id' => 'nid',
          ),
          'table' => 'node',
        ),
      ),
      'indexes' => array(
        'target_id' => array(
          0 => 'target_id',
        ),
      ),
      'locked' => '1',
      'module' => 'entityreference',
      'settings' => array(
        'handler' => 'base',
        'handler_settings' => array(
          'sort' => array(
            'type' => 'none',
          ),
          'target_bundles' => array(),
        ),
        'target_type' => 'certification_rule',
      ),
      'translatable' => '0',
      'type' => 'entityreference',
    );
    field_create_field($field);

    // Create the 'field_certified_rule_ref' instance on the bundle.
    $instance = array(
      'bundle' => 'certification',
      'default_value' => NULL,
      'deleted' => '0',
      'description' => '',
      'locked' => '1',
      'display' => array(
        'default' => array(
          'label' => 'above',
          'module' => 'entityreference',
          'settings' => array(
            'link' => 1,
          ),
          'type' => 'entityreference_label',
          'weight' => '3',
        ),
      ),
      'entity_type' => 'certification',
      'field_name' => 'field_certified_rule_ref',
      'label' => 'Certification Rule',
      'required' => 1,
      'settings' => array(
        'user_register_form' => FALSE,
      ),
      'widget' => array(
        'active' => 1,
        'module' => 'options',
        'settings' => array(),
        'type' => 'options_select',
        'weight' => '4',
      ),
    );
    field_create_instance($instance);
  }
}

