<?php

/*
 * Installs fields and field instances for certification_rule entity
 *
 */
function civicrm_certify_certification_rule_fields() {

  // Create the 'field_cert_rule_civievent' field if it doesn't already exist.
  if (!field_info_field('field_cert_rule_civievent')) {
    $field = array(
      'active' => '1',
      'cardinality' => '1',
      'deleted' => '0',
      'entity_types' => array(),
      'field_name' => 'field_cert_rule_civievent',
      'foreign keys' => array(),
      'indexes' => array(
        'value' => array(
          0 => 'value',
        ),
      ),
      'locked' => '1',
      'module' => 'list',
      'settings' => array(
        'allowed_values' => array(
          1 => 'EventType Name 1',
          2 => 'EventType Name 2',
          3 => 'EventType Name 3',
        ),
        'allowed_values_function' => 'field_cert_rule_civievent_type_values',
      ),
      'translatable' => '0',
      'type' => 'list_integer',
    );
    field_create_field($field);

    // Create the 'field_cert_rule_civievent' instance on the bundle.
    $instance = array(
      'bundle' => 'certification_rule',
      'locked' => '1',
      'default_value' => NULL,
      'deleted' => '0',
      'description' => '',
      'display' => array(
        'default' => array(
          'label' => 'above',
          'module' => 'list',
          'settings' => array(),
          'type' => 'list_default',
          'weight' => '4',
        ),
      ),
      'entity_type' => 'certification_rule',
      'field_name' => 'field_cert_rule_civievent',
      'label' => 'CiviEvent Type',
      'label' => 'CiviEvent Type',
      'required' => 1,
      'settings' => array(
        'user_register_form' => FALSE,
      ),
      'widget' => array(
        'active' => 1,
        'module' => 'options',
        'settings' => array(),
        'type' => 'options_select',
        'weight' => '-1',
      ),
    );
    field_create_instance($instance);
  }
  // Create the 'field_cert_rule_particpant_stat' field if it doesn't already exist.
  if (!field_info_field('field_cert_rule_particpant_stat')) {
    // Create the 'field_cert_rule_particpant_stat' field.
    $field = array(
      'active' => '1',
      'cardinality' => '1',
      'deleted' => '0',
      'entity_types' => array(),
      'field_name' => 'field_cert_rule_particpant_stat',
      'foreign keys' => array(),
      'indexes' => array(
        'value' => array(
          0 => 'value',
        ),
      ),
      'locked' => '1',
      'module' => 'list',
      'settings' => array(
        'allowed_values' => array(
          1 => 'Participant Status 1',
          2 => 'Participant Status 2',
          3 => 'Participant Status 3',
        ),
        'allowed_values_function' => 'field_cert_rule_participant_status_values',
      ),
      'translatable' => '0',
      'type' => 'list_integer',
    );
    field_create_field($field);

    // Create the 'field_cert_rule_particpant_stat' instance on the bundle.
    $instance = array(
      'bundle' => 'certification_rule',
      'locked' => '1',
      'default_value' => NULL,
      'deleted' => '0',
      'description' => '',
      'display' => array(
        'default' => array(
          'label' => 'above',
          'module' => 'list',
          'settings' => array(),
          'type' => 'list_default',
          'weight' => '5',
        ),
      ),
      'entity_type' => 'certification_rule',
      'field_name' => 'field_cert_rule_particpant_stat',
      'label' => 'Participant Status',
      'required' => 1,
      'settings' => array(
        'user_register_form' => FALSE,
      ),
      'widget' => array(
        'active' => 1,
        'module' => 'options',
        'settings' => array(),
        'type' => 'options_select',
        'weight' => '-1',
      ),
    );
    field_create_instance($instance);
  }

  if (!field_info_field('field_cert_rule_civigroup      ')) {
    // Create the 'field_cert_rule_civigroup' field.
    $field = array(
      'active' => '1',
      'cardinality' => '1',
      'deleted' => '0',
      'entity_types' => array(),
      'field_name' => 'field_cert_rule_civigroup',
      'foreign keys' => array(),
      'indexes' => array(
        'value' => array(
          0 => 'value',
        ),
      ),
      'locked' => '1',
      'module' => 'list',
      'settings' => array(
        'allowed_values' => array(
          1 => 'GroupName 1',
          2 => 'GroupName 2',
          3 => 'GroupName 3',
        ),
        'allowed_values_function' => 'field_cert_rule_civigroup_values',
      ),
      'translatable' => '0',
      'type' => 'list_integer',
    );
    field_create_field($field);

    // Create the 'field_cert_rule_civigroup' instance on the bundle.
    $instance = array(
      'bundle' => 'certification_rule',
      'locked' => '1',
      'default_value' => NULL,
      'deleted' => '0',
      'description' => '',
      'display' => array(
        'default' => array(
          'label' => 'above',
          'module' => 'list',
          'settings' => array(),
          'type' => 'list_default',
          'weight' => '4',
        ),
      ),
      'entity_type' => 'certification_rule',
      'field_name' => 'field_cert_rule_civigroup',
      'label' => 'CiviGroup',
      'required' => 1,
      'settings' => array(
        'user_register_form' => FALSE,
      ),
      'widget' => array(
        'active' => 1,
        'module' => 'options',
        'settings' => array(),
        'type' => 'options_select',
        'weight' => '-1',
      ),
    );
    field_create_instance($instance);
  }

  if (!field_info_field('field_cert_rule_description')) {
    // Create the 'field_cert_rule_description' field.
    $field = array(
      'active' => '1',
      'cardinality' => '1',
      'deleted' => '0',
      'entity_types' => array(),
      'field_name' => 'field_cert_rule_description',
      'foreign keys' => array(
        'format' => array(
          'columns' => array(
            'format' => 'format',
          ),
          'table' => 'filter_format',
        ),
      ),
      'indexes' => array(
        'format' => array(
          0 => 'format',
        ),
      ),
      'locked' => '1',
      'module' => 'text',
      'settings' => array(),
      'translatable' => '0',
      'type' => 'text_long',
    );
    field_create_field($field);

    // Create the 'field_cert_rule_description' instance on the bundle.
    $instance = array(
      'bundle' => 'certification_rule',
      'default_value' => NULL,
      'locked' => '1',
      'deleted' => '0',
      'description' => '',
      'display' => array(
        'default' => array(
          'label' => 'above',
          'module' => 'text',
          'settings' => array(),
          'type' => 'text_default',
          'weight' => 0,
        ),
        'teaser' => array(
          'label' => 'above',
          'settings' => array(),
          'type' => 'hidden',
          'weight' => 0,
        ),
      ),
      'entity_type' => 'certification_rule',
      'field_name' => 'field_cert_rule_description',
      'label' => 'Description',
      'required' => 0,
      'settings' => array(
        'text_processing' => '0',
        'user_register_form' => FALSE,
      ),
      'widget' => array(
        'active' => 1,
        'module' => 'text',
        'settings' => array(
          'rows' => '5',
        ),
        'type' => 'text_textarea',
        'weight' => '-4',
      ),
    );
    field_create_instance($instance);
  }
}

